# #! /bin/bash

# this will break the training downloaded data into 5 sub-folders for each fish source and camera angle
# then within each one of those, there will be 2 sub-folders, one for labels and one for images
# where the images have some fishless images included, exactly 20 for each fish source, and those fishless images will not have associated label files

#This will divide train_x and train_y into their separate sources and then delete them,
#so we need to make sure there is another copy if we don't want that deleted permanently

#to start this, you need to have train_x and train_y in a folder at the 'dataset_parent_directory/data_folder_name' address
dataset_parent_directory="/Users/victoriasabo/Documents/WPTO"
data_folder_name="Data"
out_directory="/Users/victoriasabo/Documents/eyesea-yolo/scripts/data/train_files_few_fishless"

python3 scripts/data_processing_scripts/split_datasets_by_source_Ig_article.py $dataset_parent_directory $data_folder_name $out_directory

#this will create a new folder train_files with 5 sub-folders, one for each source (Ig has 3 diff camera angles
#Each of these 5 sub-folders will have an 'images_first_iter' and 'labels_first_iter' subfolders
#it will also make sure each of those sub folders is empty to begin with, so no files are saved more than once
#then it will delete the original train_x and train_y to save space

#then you take each of those 'labels_first_iter' labels, convert them to txts in just a 'labels' folder, and then
#split images into fish and no fish and just output the fish images into a folder called 'images'
list_fish_sources=('Igiugig_1' 'Igiugig_2' 'Igiugig_3' 'Voith' 'WellsDam')
number_fishless_images_to_include=('20' 20 20 20 20) #this adds exactly only 20 fishless images to each source, which is what we define as 'fewfishless'
iter=0
for fish_source in "${list_fish_sources[@]}"
do
    in_dir_lab=$out_directory"/"$fish_source"/labels_first_iter"
    in_dir_im=$out_directory"/"$fish_source"/images_first_iter"
    txt_file_loc=$out_directory"/"$fish_source"/labels"
    out_dir_im=$out_directory"/"$fish_source"/images"
    python3 scripts/data_processing_scripts/convert_txt_and_split_fish_article_incl_fishless.py $in_dir_lab $in_dir_im $txt_file_loc $out_dir_im ${number_fishless_images_to_include[$iter]}
    iter=$iter+1
done